tigase.disco

## Interface XMPPService

- All Superinterfaces:
    ServerComponent
  All Known Implementing Classes:
    AbstractComponent, AbstractComponentRegistrator, AbstractMessageReceiver, AmpComponent, AmpComponentClustered, BasicComponent, BoshConnectionClustered, BoshConnectionManager, ClientConnectionClustered, ClientConnectionManager, ClusterConnectionManager, ClusterController, ComponentConnectionManager, ComponentProtocol, Configurator, ConfiguratorAbstract, ConfiguratorOld, ConnectionManager, EchoComponent, EventBusComponent, MessageRouter, MonitorClustered, MonitorComponent, MonitorComponent, S2SConnectionManager, ServerConnectionManager, SessionManager, SessionManagerClustered, StanzaReceiver, StanzaSender, StatisticsCollector, TestComponent, VHostManager, VirtualComponent, WebSocketClientConnectionClustered, WebSocketClientConnectionManager, XMPPServiceCollector

      public interface XMPPService
      extends ServerComponent

  Interface XMPPService Objects which implement this interface can respond to "ServiceDiscovery" requests. All such requests are managed by MessageRouter instance. Created: Tue Nov 22 07:07:11 2005
  Version:
    $Rev$
  Author:
    Artur Hefczyc

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String[]` | `CMD_FEATURES` A convenience constant with component features related to ad-hoc commands.
    `static String[]` | `DEF_FEATURES` A convenience constant with all stream features for service discovery.
    `static String` | `INFO_XMLNS` A convenience constant with service discovery info xmlns string.
    `static String` | `ITEMS_XMLNS` A convenience constant with service discovery items xmlns string.

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `List<Element>` | `getDiscoFeatures(JID from)` Returns features for top level disco info
    `Element` | `getDiscoInfo(String node, JID jid, JID from)` Returns service discovery info for the component.
    `List<Element>` | `getDiscoItems(String node, JID jid, JID from)` Returns service discovery items for the component.

    - ### Methods inherited from interface tigase.server.ServerComponent

      `getComponentId, getComponentInfo, getName, initializationCompleted, isInitializationComplete, processPacket, release, setName`

- - ### Field Detail

    - #### INFO_XMLNS

          static final String INFO_XMLNS

      A convenience constant with service discovery info xmlns string.
      See Also:
        Constant Field Values

    - #### ITEMS_XMLNS

          static final String ITEMS_XMLNS

      A convenience constant with service discovery items xmlns string.
      See Also:
        Constant Field Values

    - #### DEF_FEATURES

          static final String[] DEF_FEATURES

      A convenience constant with all stream features for service discovery.

    - #### CMD_FEATURES

          static final String[] CMD_FEATURES

      A convenience constant with component features related to ad-hoc commands.

  - ### Method Detail

    - #### getDiscoInfo

          Element getDiscoInfo(String node,
                               JID jid,
                               JID from)

      Returns service discovery info for the component. If the jid is null then this is info for the top level request. SM may return disco info on the top level. Other components should not.
      Parameters:
        `node` - is service discovery node for which the request is made. Is normally null for the component top level request.
        `jid` - is the jid to which the request has been made.
        `from` - is the request sender address. Some service discovery information is only meant for administrators.
      Returns:
        returns an XML Element with service discovery data.

    - #### getDiscoItems

          List<Element> getDiscoItems(String node,
                                      JID jid,
                                      JID from)

      Returns service discovery items for the component. If the JID is null then this is request for the top level request. SM may return disco items on the top level, other components should just return it's top level service discovery item for null node.
      Parameters:
        `node` - is a service discovery node for which the request has been made.
        `jid` - is the jid to which the request has been made.
        `from` - is the request sender address. Some service discovery information is only meant for administrators.
      Returns:
        a list of service discovery items for this component or the component itself disco item for the top level request.

    - #### getDiscoFeatures

          List<Element> getDiscoFeatures(JID from)

      Returns features for top level disco info
      Parameters:
        `from` - a request sender address. Some service disco elements are meant to be available only to system administrarors. The component is responsible to check whether the sender is the component administrator and return results appropriate.
      Returns:
        a list of elements with service discovery features.

Copyright © 2022 "Tigase, Inc.". All rights reserved.